# VALIDATION AND VERIFICATION PROCESS

*This section describes the validation process and the verification process. The validation process provides assurance that the hardware item derived requirements are correct and complete with respect to system requirements allocated to the hardware item. The verification process provides assurance that the hardware item implementation meets all of the hardware requirements, including derived requirements.*

| Data Required for the Hardware Verification Review  |
|:----------------------------------------------------|
| Hardware Requirements Data                          |
| Hardware Design Representation Data                 |
| Hardware Description Language                       |
| Hardware Design Schematics                          |
| Hardware Verification Procedures                    |
| Hardware Verification Results                       |
| Hardware Life Cycle Environment Configuration Index |
| Problem Reports                                     |
| Hardware Configuration Management Records           |
| Hardware Process Assurance Records                  |
| Hardware Tool Qualification Data                    |
:Data Required for the Hardware Verification Review

.. ....... ........ ........ ....... .. ........... ...... .... .. ...... ..... .. ..... .... ........ ... ...... . ... .... .. ......... ........... .... .... ........ .. .... . ..... ....... .... ... ........ .... ............ .. ... ... ....... .. ...... .... ... .... ....... .. ..... ... .... ....... ... ....... ......... ..... .......... ....... ..... ....... ... ....... ... ....... ..... ..... .... . ........ .. ... ..... ......... .. ........ ..... ....... .......... .......... ... ........ .. ... ..... .. ........ ..... .......... .... ... ...... .. .....

## Validation Process

*The validation process discussed here is intended to ensure that the derived requirements are correct and complete with respect to the system requirements allocated to the hardware item through the use of a combination of objective and subjective processes. Validation may be conducted before or after the hardware item is available, however, validation is typically conducted throughout the design life cycle.*

## Verification Process

*The verification process provides assurance that the hardware item implementation meets the requirements. Verification consists of reviews, analyses and tests applied as defined in the verification plan. The verification process should include an assessment of the results.*

## Validation and Verification Methods

*This section describes some methods that may be applicable to both validation and verification.*
