# Hardware Plans

*The hardware plans describe the processes, procedures, methods, and standards to be used for the hardware certification, design, validation, verification, process assurance and configuration control.*

.. ....... ........ ........ ....... .. ........... ...... .... .. ...... ..... .. ..... .... ........ ... ...... . ... .... .. ......... ........... .... .... ........ .. .... . ..... ....... .... ... ........ .... ............ .. ... ... ....... .. ...... .... ... .... ....... .. ..... ... .... ....... ... ....... ......... ..... .......... ....... ..... ....... ... ....... ... ....... ..... ..... .... . ........ .. ... ..... ......... .. ........ ..... ....... .......... .......... ... ........ .. ... ..... .. ........ ..... .......... .... ... ...... .. .....

* Data Required for the Final Certification Hardware
  * Hardware Accomplishment Summary
  * Hardware Configuration Index
  * Hardware Configuration Management Records
  * Hardware Life Cycle Environment Configuration Index
  * Hardware Process Assurance Records
  * Hardware Verification Results
  * Problem Reports
* Data Required for the Hardware Development
  * Hardware Configuration Management Records
  * Hardware Design Data
  * Hardware Design Schematics
  * Hardware Life Cycle Environment Configuration Index
  * Hardware Process Assurance Records
  * Hardware Requirements
  * Hardware Requirements Design and HDL Code Standards
  * Hardware Review and Analysis Procedures
  * Hardware Review and Analysis Results
  * Hardware Tool Qualification Data
  * Hardware Traceability Data
  * HDL
  * Problem Reports
* Data Required for the Hardware Planning Review
  * Hardware Configuration Management Plan
  * Hardware Design Plan
  * Hardware Process Assurance Plan
  * Hardware Process Assurance Records
  * Hardware Requirements Design HDL Code Validation and Verification and Archive Standards
  * Hardware Validation Plan
  * Hardware Verification Plan
  * Plan for Hardware Aspects of Certification
  * Supplier Management Plan
  * Tool Qualification Plans
* Data Required for the Hardware Verification
  * Hardware Configuration Management Records
  * Hardware Design Representation Data
  * Hardware Design Schematics
  * Hardware Life Cycle Environment Configuration Index
  * Hardware Process Assurance Records
  * Hardware Requirements Data
  * Hardware Tool Qualification Data
  * Hardware Verification Procedures
  * Hardware Verification Results
  * HDL
  * Problem Reports

.. ....... ........ ........ ....... .. ........... ...... .... .. ...... ..... .. ..... .... ........ ... ...... . ... .... .. ......... ........... .... .... ........ .. .... . ..... ....... .... ... ........ .... ............ .. ... ... ....... .. ...... .... ... .... ....... .. ..... ... .... ....... ... ....... ......... ..... .......... ....... ..... ....... ... ....... ... ....... ..... ..... .... . ........ .. ... ..... ......... .. ........ ..... ....... .......... .......... ... ........ .. ... ..... .. ........ ..... .......... .... ... ...... .. .....

* Data Required for the Final Certification Hardware
  * Hardware Accomplishment Summary
  * Hardware Configuration Index
  * Hardware Configuration Management Records
  * Hardware Life Cycle Environment Configuration Index
  * Hardware Process Assurance Records
  * Hardware Verification Results
  * Problem Reports
* Data Required for the Hardware Development
  * Hardware Configuration Management Records
  * Hardware Design Data
  * Hardware Design Schematics
  * Hardware Life Cycle Environment Configuration Index
  * Hardware Process Assurance Records
  * Hardware Requirements
  * Hardware Requirements Design and HDL Code Standards
  * Hardware Review and Analysis Procedures
  * Hardware Review and Analysis Results
  * Hardware Tool Qualification Data
  * Hardware Traceability Data
  * HDL
  * Problem Reports
* Data Required for the Hardware Planning Review
  * Hardware Configuration Management Plan
  * Hardware Design Plan
  * Hardware Process Assurance Plan
  * Hardware Process Assurance Records
  * Hardware Requirements Design HDL Code Validation and Verification and Archive Standards
  * Hardware Validation Plan
  * Hardware Verification Plan
  * Plan for Hardware Aspects of Certification
  * Supplier Management Plan
  * Tool Qualification Plans
* Data Required for the Hardware Verification
  * Hardware Configuration Management Records
  * Hardware Design Representation Data
  * Hardware Design Schematics
  * Hardware Life Cycle Environment Configuration Index
  * Hardware Process Assurance Records
  * Hardware Requirements Data
  * Hardware Tool Qualification Data
  * Hardware Verification Procedures
  * Hardware Verification Results
  * HDL
  * Problem Reports

.. ....... ........ ........ ....... .. ........... ...... .... .. ...... ..... .. ..... .... ........ ... ...... . ... .... .. ......... ........... .... .... ........ .. .... . ..... ....... .... ... ........ .... ............ .. ... ... ....... .. ...... .... ... .... ....... .. ..... ... .... ....... ... ....... ......... ..... .......... ....... ..... ....... ... ....... ... ....... ..... ..... .... . ........ .. ... ..... ......... .. ........ ..... ....... .......... .......... ... ........ .. ... ..... .. ........ ..... .......... .... ... ...... .. .....

| Data Required for the Hardware Planning Review                                            |
|:------------------------------------------------------------------------------------------|
| Plan for Hardware Aspects of Certification                                                |
| Hardware Design Plan                                                                      |
| Hardware Validation Plan                                                                  |
| Hardware Verification Plan                                                                |
| Hardware Configuration Management Plan                                                    |
| Hardware Process Assurance Plan                                                           |
| Hardware Process Assurance Records                                                        |
| Hardware Requirements, Design, HDL Code, Validation & Verification, and Archive Standards |
| Tool Qualification Plans                                                                  |
| Supplier Management Plan                                                                  |
:Data Required for the Hardware Planning Review

.. ....... ........ ........ ....... .. ........... ...... .... .. ...... ..... .. ..... .... ........ ... ...... . ... .... .. ......... ........... .... .... ........ .. .... . ..... ....... .... ... ........ .... ............ .. ... ... ....... .. ...... .... ... .... ....... .. ..... ... .... ....... ... ....... ......... ..... .......... ....... ..... ....... ... ....... ... ....... ..... ..... .... . ........ .. ... ..... ......... .. ........ ..... ....... .......... .......... ... ........ .. ... ..... .. ........ ..... .......... .... ... ...... .. .....

| Data Required for the Hardware Planning Object                                            |
|:------------------------------------------------------------------------------------------|
| Plan for Hardware Aspects of Certification                                                |
| Hardware Design Plan                                                                      |
| Hardware Validation Plan                                                                  |
| Hardware Verification Plan                                                                |
| Hardware Configuration Management Plan                                                    |
| Hardware Process Assurance Plan                                                           |
| Hardware Process Assurance Records                                                        |
| Hardware Requirements, Design, HDL Code, Validation & Verification, and Archive Standards |
| Tool Qualification Plans                                                                  |
| Supplier Management Plan                                                                  |
:Data Required for the Hardware Planning Object

.. ....... ........ ........ ....... .. ........... ...... .... .. ...... ..... .. ..... .... ........ ... ...... . ... .... .. ......... ........... .... .... ........ .. .... . ..... ....... .... ... ........ .... ............ .. ... ... ....... .. ...... .... ... .... ....... .. ..... ... .... ....... ... ....... ......... ..... .......... ....... ..... ....... ... ....... ... ....... ..... ..... .... . ........ .. ... ..... ......... .. ........ ..... ....... .......... .......... ... ........ .. ... ..... .. ........ ..... .......... .... ... ...... .. .....

## Plan for Hardware Aspects of Certification

*The PHAC defines the processes, procedures, methods and standards to be used to achieve the objectives of this document and obtain certification authority approval for certification of the system containing hardware items. The PHAC, once approved, represents an agreement between the certification applicant and the certification authority on the processes and activities to be conducted and the resultant evidence to be produced to satisfy the hardware aspects of certification. The PHAC may be part of another plan, such as the airborne system certification plan.*

## Hardware Design Plan

*The hardware design plan describes the procedures, methods and standards to be applied and the processes and activities to be conducted for the design of the hardware item. This plan may be included in the PHAC and may reference design policies and standards to be applied.*

## Hardware Validation Plan

*The validation plan describes the procedures, methods and standards to be applied and the processes and activities to be conducted for the validation of the hardware item derived requirements to achieve the validation objectives of this document. This plan may be included in the PHAC and may reference validation standards to be applied.*

## Hardware Verification Plan

*The verification plan describes the procedures, methods and standards to be applied and the processes and activities to be conducted for the verification of the hardware items to achieve the verification objectives of this document. This plan may be included in the PHAC and may reference verification policies and standards to be applied.*

## Hardware Configuration Management Plan

*The hardware configuration management plan describes the policies, procedures, standards and methods to be used to satisfy the configuration management objectives of this document.*

## Hardware Process Assurance Plan

*The hardware process assurance plan describes the procedures, methods and standards to be applied and the processes and activities to be conducted for achieving the process assurance objectives of this document.*
